LMS/LMS/Controllers/AuthorsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using LMS.Data;
using LMS.Data.Data.Entities;
using Microsoft.AspNetCore.Authorization;
using LMS.Models;
using LMS.Infrastructure.Mappers.Contracts;
using LMS.ServiceLayer.Services;

namespace LMS.Controllers
{
    [Authorize(Roles = "Admin")]
    public class AuthorsController : Controller
    {
        private readonly LMSDbContext context;
        private readonly IAuthorService authorService;

        public AuthorsController(LMSDbContext context,IAuthorService authorService)/*, IViewModelMapper<Author,AuthorViewModel> authorVMMapper*/
        {
            this.context = context;
            this.authorService = authorService;
        }

        // GET: Authors
        public async Task<IActionResult> Index()
        {
            return View(await authorService.GetAuthorsAsync());
        }

        // GET: Authors/Details/5
        public async Task<IActionResult> Details(string id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var author = await authorService.GetAuthorAsync(id);
            if (author == null)
            {
                return NotFound();
            }

            return View(author);
        }

        // GET: Authors/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: Authors/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        //public async Task<IActionResult> Create(AuthorViewModel authorViewModel)
        //{
        //    authorvm
        //    if (ModelState.IsValid)
        //    {
        //        _context.Add(author);
        //        await _context.SaveChangesAsync();
        //        return RedirectToAction(nameof(Index));
        //    }
        //    return View(author);
        //}
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(AuthorViewModel authorViewModel)
        {
            var author = await authorService.CreateAuthorAsync(authorViewModel.Name);
            if (ModelState.IsValid)
            {
                return RedirectToAction(nameof(Index));
            }
            return View(author);
        }

        // GET: Authors/Edit/5
        public async Task<IActionResult> Edit(string id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var author = await authorService.GetAuthorAsync(id);
            if (author == null)
            {
                return NotFound();
            }

            return View(author);
        }

        // POST: Authors/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(string id, AuthorViewModel authorViewModel)
        {
            var author = await authorService.GetAuthorAsync(id);
            author.Name = authorViewModel.Name;

            if (ModelState.IsValid)
            {
                try
                {
                    await authorService.Edit(author);
                }
                catch (DbUpdateConcurrencyException)
                {
                        return NotFound();
                }
                return RedirectToAction(nameof(Index));
            }

            return View(author);
        }

        // GET: Authors/Delete/5
        public async Task<IActionResult> Delete(string id)
        {
            if (id == null)
            {
                return NotFound();
            }
            var author = await authorService.GetAuthorAsync(id);

            return View(author);
        }

        // POST: Authors/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(string id)
        {
            await this.authorService.DeleteAuthor(id);

            return RedirectToAction(nameof(Index));
        }
    }
}

LMS/LMS/Controllers/BooksController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using LMS.Data;
using LMS.Data.Data.Entities;
using LMS.Models;
using LMS.ServiceLayer.Contracts;
using LMS.Infrastructure.Extensions;
using Microsoft.AspNetCore.Authorization;
using System.Security.Claims;
using LMS.Infrastructure.Mappers.Contracts;
using System.Threading;

namespace LMS.Controllers
{
    public class BooksController : Controller
    {
        private readonly LMSDbContext _context;//da se maha skoro
        private readonly IBookService bookService;
        private readonly IRentalManager rentalManager;
        private readonly IReservationService reservationService;
        private readonly IGradeService gradeService;
        private readonly IViewModelMapper<IReadOnlyCollection<Book>, CollectionViewModel> allBooksMapper;

        public BooksController(LMSDbContext context,
                               IBookService bookService,
                               IRentalManager rentalManager,
                               IReservationService reservationService,
                               IGradeService gradeService,
                               IViewModelMapper<IReadOnlyCollection<Book>, CollectionViewModel> allBooksMapper)
        {
            _context = context;
            this.bookService = bookService ?? throw new ArgumentNullException(nameof(bookService));
            this.rentalManager = rentalManager ?? throw new ArgumentNullException(nameof(rentalManager));
            this.reservationService = reservationService ?? throw new ArgumentNullException(nameof(reservationService));
            this.gradeService = gradeService;
            this.allBooksMapper = allBooksMapper ?? throw new ArgumentNullException(nameof(allBooksMapper));
        }

        [Authorize]
        public async Task<IActionResult> MyBooks()
        {
            string userId = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            var books = await bookService.GetUserBooks(userId);
            var takenModel = allBooksMapper.MapFrom(books);

            var reservedBooks = await bookService.GetReservedBooksByUser(userId);
            var reservedModel = allBooksMapper.MapFrom(reservedBooks);

            foreach (var item in takenModel.Books)
            {
                item.CurrentUserId = userId;
            }
            var myBooksModel = new MyBooksViewModel()
            {
                ReservedBooks = reservedModel,
                TakenBooks = takenModel
            };

            return View(myBooksModel);
        }

        [Authorize]
        public async Task<IActionResult> Checkout(string bookId)
        {
            string userid = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            try
            {
                var book = await rentalManager.ChechkoutBookAsync(userid, bookId);

                return Redirect("MyBooks");
            }
            catch (Exception ex)
            {
                var vm = new ErrorViewModel();
                vm.ErrorDescription = ex.Message;

                return RedirectToAction("Index", "ErrorHandler", vm);
            }
        }
        [Authorize]
        public async Task<IActionResult> Return(string bookId)
        {
            string userid = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            var book = await rentalManager.ReturnBookAsync(userid, bookId);

            return Redirect("Details/" + book.Id);
        }

        [Authorize]
        public async Task<IActionResult> Reserve(string bookId)
        {
            string userid = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            var reservation = await reservationService.Create(userid, bookId);

            return Redirect("MyBooks");
        }

        [HttpGet] //("/Book/Details/{Id}")
        public async Task<IActionResult> GetReviews(string id) // <-- bookId
        {
            // TODO REMOVE!
            //Thread.Sleep(2000);

            var grades = await this.gradeService.GetGrades(id);


            var gradesViewModel = new List<GradeViewModel>();

            foreach (var item in grades)
            {
                var vm = new GradeViewModel()
                {
                    Title = item.Book.Title,
                    Rating = item.Rating,
                    Review = item.Review,
                    ReviewAuthor = item.User.UserName
                };
                gradesViewModel.Add(vm);
            }

            //return View(gradesViewModel);
            //return Json(gradesViewModel);
            return PartialView("GetReviews", gradesViewModel);
        }

        public async Task< IActionResult> GetJsReviews()
        {
            var books = await this.bookService.GetBooks();

            return Json(books);
        }

        [Authorize]
        // GET: Books/Details/5
        public async Task<IActionResult> Details(BookViewModel bookVM)
        {

            var book = await bookService.GetBook(bookVM.Id);

            var bookvm = book.MapFrom();

            return View(bookvm);
        }

        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            ViewData["StatusId"] = new SelectList(_context.Statuses, "Id", "Id");
            ViewData["AuthorsNames"] = new SelectList(_context.Authors.Select(a => a.Name).ToList());

            return View();
        }

        public IActionResult Reviews()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(CreateBookViewModel createBookViewModel)
        {
            //var book = createBookVMMapper.MapFrom(createBookViewModel);
            //var createdbook = await bookService.CreateBook(book);
            var book = await bookService
                .CreateBook(createBookViewModel.Title, createBookViewModel.Year, createBookViewModel.AuthorsNames);

            return RedirectToAction(nameof(Index));
        }

        [Authorize(Roles = "Admin")]
        // GET: Books/Edit/5
        //TODO REMOVE
        public async Task<IActionResult> Edit(string id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var book = await _context.Books.FindAsync(id);
            if (book == null)
            {
                return NotFound();
            }
            ViewData["StatusId"] = new SelectList(_context.Statuses, "Id", "Id", book.StatusId);
            return View(book);
        }

        //TODO
        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(string id, [Bind("Id,Title,Year,RentalId,StatusId")] Book book)
        {
            if (id != book.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(book);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!BookExists(book.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            ViewData["StatusId"] = new SelectList(_context.Statuses, "Id", "Id", book.StatusId);
            return View(book);
        }

        [Authorize(Roles = "Admin")]
        // GET: Books/Delete/5
        //TODO
        public async Task<IActionResult> Delete(string id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var book = await _context.Books
                .Include(b => b.Status)
                .FirstOrDefaultAsync(m => m.Id == id);
            if (book == null)
            {
                return NotFound();
            }

            return View(book);
        }

        // POST: Books/Delete/5
        [HttpPost, ActionName("Delete")]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(string id)
        {
            var book = await _context.Books.FindAsync(id);
            _context.Books.Remove(book);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool BookExists(string id)
        {
            return _context.Books.Any(e => e.Id == id);
        }
        public async Task<IActionResult> Index(string sortOrder, string searchString, int Id=1)
        {
            CollectionViewModel model;
            var currentPageBooks = await this.bookService.GetCurrentPageBooks(Id);
            var allBooks = await bookService.GetBooks();
            string userid = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;

            ViewData["NameSortParam"] = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";
            ViewData["DateSortParam"] = sortOrder == "date_desc" ? "Date" : "date_desc";
            ViewData["RatingSortParam"] = sortOrder == "rate_desc" ? "Rating" : "rate_desc";
            ViewData["AuthorSortParam"] = sortOrder == "Author" ? "auth_desc" : "Author";
            ViewData["StatusSortParam"] = sortOrder == "Status" ? "stat_desc" : "Status";

            ViewData["CurrentFilter"] = searchString;

            if (!String.IsNullOrEmpty(searchString))
            {
                model = allBooksMapper.MapFrom(allBooks);
                var lower = searchString.ToLower();
                model.Books = model.Books.Where(b => b.Title.ToLower().Contains(lower)

LMS/LMS/Controllers/GradesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using LMS.Data.Data.Entities;
using LMS.Infrastructure.Mappers.Contracts;
using LMS.Models;
using LMS.ServiceLayer.Contracts;
using Microsoft.AspNetCore.Mvc;

namespace LMS.Controllers
{
    public class GradesController : Controller
    {
        private readonly IGradeService gradeService;
        private readonly IViewModelMapper<Grade, GradeViewModel> gradeViewModelMapper;
        private readonly IViewModelMapper<GradeViewModel, Grade> grademodelMapper;

        public GradesController(IGradeService gradeService,
                                IViewModelMapper<Grade, GradeViewModel> gradeViewModelMapper,
                                IViewModelMapper<GradeViewModel, Grade> grademodelMapper)
        {

            this.gradeService = gradeService ?? throw new ArgumentNullException(nameof(gradeService));
            this.gradeViewModelMapper = gradeViewModelMapper ?? throw new ArgumentNullException(nameof(gradeViewModelMapper));
            this.grademodelMapper = grademodelMapper;
        }
        public IActionResult Index()
        {

            return View();
        }
        [HttpGet]
        public async Task<IActionResult> Review(string Id)
        {
            try
            {
                var userId = this.User.FindFirst(ClaimTypes.NameIdentifier).Value;
                if (await gradeService.CheckIfBookIsRated(Id, userId))
                {
                    throw new Exception("You have already reviewed this book!");
                }
            }
            catch (Exception ex)
            {
                var vm = new ErrorViewModel();
                vm.ErrorDescription = ex.Message;

                return RedirectToAction("Index", "ErrorHandler", vm);
            }
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Review(GradeViewModel gradeViewModel)
        {
            var userId = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            var grade = await this.gradeService.Create(gradeViewModel.Id, userId, gradeViewModel.Rating, gradeViewModel.Review);

            return RedirectToAction("Index", "Books");
        }
        [HttpGet]
        public async Task<IActionResult> Edit(string Id)
        {
            var userId = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            var grade = await gradeService.GetGrade(Id, userId);
            var gradeVM = gradeViewModelMapper.MapFrom(grade);

            return View(gradeVM);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(GradeViewModel gradeViewModel)
        {
            var userId = this.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            gradeViewModel.UserId = userId;
            var grade = grademodelMapper.MapFrom(gradeViewModel);
            var editedGrade = await gradeService.Edit(grade);

            return RedirectToAction("Index", "Books");
        }
    }


}

//https://localhost:44343/Grades/Edit/758daecf-2462-44ed-8e59-b95a3657b7b5

LMS/LMS/Views/Shared/_BooksPartial.cshtml
@model IEnumerable<BookViewModel>

<div class="col-md-8">
    <h4>Books</h4>
    <table class="table table-hover">
        <thead class="thead-light">
            <tr>
                <th>
                    @Html.DisplayNameFor(model => model.Name)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Title)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Year)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Status)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Rating)
                </th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.Name)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Title)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Year)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Status)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Rating)
                    </td>
                    <td>
                        <div class="btn-group btn-group-sm" role="group" aria-label="Basic example">
                            <button type="button" class="btn btn-secondary bg-transparent border-0">
                                <a asp-controller="Books" asp-action="Edit" asp-route-id="@item.Id">
                                    <img class="d-flex ml-3" src="~/lib/images/EditGreenTrans.png" alt="Edit" width="100">
                                </a>
                            </button>
                            <button type="button" class="btn btn-secondary bg-transparent border-0">
                                <a asp-controller="Books" asp-action="Details" asp-route-id="@item.Id">
                                    <img class="d-flex ml-3" src="~/lib/images/DetailsYellowTrans.png" alt="Details" width="100">
                                </a>
                            </button>
                            <button type="button" class="btn btn-secondary bg-transparent border-0">
                                <a asp-controller="Books" asp-action="Delete" asp-route-id="@item.Id">
                                    <img class="d-flex ml-3" src="~/lib/images/DeleteRedTrans.png" alt="Delete" width="100">
                                </a>
                            </button>
                        </div>

                        @*@Html.ActionLink("Edit", "Edit", new { /* id=item.PrimaryKey */ })
                            @Html.ActionLink("Details", "Details", new { /* id=item.PrimaryKey */ })
                            @Html.ActionLink("Delete", "Delete", new { /* id=item.PrimaryKey */ })*@
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>

LMS/LMS/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - LMS</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" />
    </environment>
    <link rel="stylesheet" href="~/css/site.css" />
    <link href="https://fonts.googleapis.com/css?family=Berkshire+Swash|Gloria+Hallelujah|Grenze&display=swap" rel="stylesheet">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link href="~/css/select2.min.css" rel="stylesheet" />


</head>
<body bgcolor="#c9c9c9">
    <header>
        <nav id="nav-font" class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light border-bottom box-shadow mb-3 font-italic">

            <div id="mySidenav" class="sidenav">
                <a href="javascript:void(0)" class="closebtn" onclick="closeNav()">&times;</a>
                @if (!this.User.Identity.IsAuthenticated)
                {
                    <a asp-area="" asp-controller="Home" asp-action="Index">
                        <div class="media">
                            <div class="media-body">
                                <h1 class="text-center mt-0 mb-1">Home</h1>
                            </div>
                        </div>
                    </a>
                    <a asp-controller="Books" asp-action="Index">
                        <div class="media">
                            <div class="media-body">
                                <h1 class="text-center mt-0 mb-1">Catalog</h1>
                            </div>
                        </div>
                    </a>
                    <a asp-area="Identity" asp-page="/Account/Login">
                        <div class="media">
                            <div class="media-body">
                                <h1 class="text-center mt-0 mb-1">Login</h1>
                            </div>
                        </div>
                    </a>
                    <a asp-area="Identity" asp-page="/Account/Register">
                        <div class="media">
                            <div class="media-body">
                                <h1 class="text-center mt-0 mb-1">Register</h1>
                            </div>
                        </div>
                    </a>
                }
                else
                {
                    if (this.User.IsBanned())
                    {
                        <a asp-area="" asp-controller="Home" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Home</h1>
                                </div>
                            </div>
                        </a>
                    }
                    else if (this.User.IsInRole("Admin"))
                    {
                        <a asp-area="" asp-controller="Home" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Home</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Authors" asp-action="Create">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Create Author</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Authors" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Authors</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Books" asp-action="Create">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Create Book</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Books" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Catalog</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Notification" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Unread messaages</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Notification" asp-action="Seen">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Seen messaages</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Ban" asp-action="BannedUsers">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Banned Users</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Grades" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Crades</h1>
                                </div>
                            </div>
                        </a>
                    }
                    else
                    {
                        <a asp-area="" asp-controller="Home" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Home</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Books" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Catalog</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Books" asp-action="MyBooks">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">My Books</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Notification" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Unread messaages</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Notification" asp-action="Seen">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Seen messaages</h1>
                                </div>
                            </div>
                        </a>
                        <a asp-area="" asp-controller="Grades" asp-action="Index">
                            <div class="media">
                                <div class="media-body">
                                    <h1 class="text-center mt-0 mb-1">Crades</h1>
                                </div>
                            </div>
                        </a>
                    }
                }
            </div>

            <!-- Use any element to open the sidenav -->
            <span onclick="openNav()">
                <img class="d-flex ml-3" src="~/lib/images/MenuWhite.png" alt="Open" width="150">
            </span>

            <!-- Add all page content inside this div if you want the side nav to push page content to the right (not used if you only want the sidenav to sit on top of the page -->
            @*<div id="main">
                    ...
                </div>*@



            <partial name="_LoginPartial" />

        </nav>
    </header>
    <div class="container">
        <partial name="_CookieConsentPartial" />
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container text-white text-decoration-none">
            &copy; CopyRight IriOnWebDesignStudios_AllRigtsReserved.Where(AboutUs => AboutUs.<b><a class="text-white" asp-area="" asp-controller="Home" asp-action="Privacy">ClickHere</a></b>)
        </div>
    </footer>


    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>
    <script src="~/js/select2.min.js"></script>
    <script src="~/js/site.js"></script>


    @RenderSection("Scripts", required: false)
</body>
</html>